import { ref, watchEffect } from "vue-demi";
const defaultShouldUpdate = (a, b) => !Object.is(a, b);
function usePrevious(state, shouldUpdate = defaultShouldUpdate) {
  const prevRef = ref();
  const curRef = ref();
  watchEffect(() => {
    if (shouldUpdate(curRef.value, state.value)) {
      prevRef.value = curRef.value;
      curRef.value = state.value;
    }
  });
  return prevRef;
}
export {
  usePrevious as default
};
