"use strict";
const vueDemi = require("vue-demi");
const event = require("./event");
function useEventEmitter(options) {
  const eventRef = vueDemi.ref();
  const eventEmitterOptions = vueDemi.computed(() => options != null ? options : { global: false });
  if (!eventRef.value) {
    eventRef.value = eventEmitterOptions.value.global ? eventRef.value = event.eventEmitterOverall : eventRef.value = new event.EventEmitter();
  }
  vueDemi.watchEffect((onInvalidate) => {
    onInvalidate(() => {
      var _a;
      return (_a = eventRef.value) == null ? void 0 : _a.clear();
    });
  });
  return eventRef.value;
}
module.exports = useEventEmitter;
