"use strict";
const vueDemi = require("vue-demi");
function useMedia(queries, values, defaultValue) {
  const mediaQueryLists = queries.map((q) => window.matchMedia(q));
  const getValue = () => {
    const index = mediaQueryLists.findIndex((mql) => mql.matches);
    return typeof values[index] !== "undefined" ? values[index] : defaultValue;
  };
  const value = vueDemi.ref(getValue());
  const handler = () => {
    value.value = getValue();
  };
  vueDemi.watchEffect((onInvalidate) => {
    mediaQueryLists.forEach((mql) => {
      mql.addListener(handler);
    });
    onInvalidate(() => {
      mediaQueryLists.forEach(
        (mql) => mql.removeListener(handler)
      );
    });
  });
  return value;
}
module.exports = useMedia;
