"use strict";
const marked = require("marked");
const vueDemi = require("vue-demi");
function usePreview(md) {
  const container = vueDemi.ref();
  const mdCompute = vueDemi.computed(() => vueDemi.unref(md));
  vueDemi.watchEffect((onInvalidate) => {
    if (mdCompute.value && container.value) {
      try {
        if (typeof mdCompute.value === "string") {
          const html = marked.marked.parse(mdCompute.value);
          if (html)
            container.value.innerHTML = html;
        } else {
          const app = vueDemi.createApp(mdCompute.value);
          app.mount(container.value);
        }
      } catch (error) {
        console.log(error);
      }
    }
    onInvalidate(() => {
      if (container.value)
        container.value.innerHTML = "";
    });
  });
  return {
    container
  };
}
module.exports = usePreview;
