"use strict";
const vueDemi = require("vue-demi");
const defaultShouldUpdate = (a, b) => !Object.is(a, b);
function usePrevious(state, shouldUpdate = defaultShouldUpdate) {
  const prevRef = vueDemi.ref();
  const curRef = vueDemi.ref();
  vueDemi.watchEffect(() => {
    if (shouldUpdate(curRef.value, state.value)) {
      prevRef.value = curRef.value;
      curRef.value = state.value;
    }
  });
  return prevRef;
}
module.exports = usePrevious;
