"use strict";
const vueDemi = require("vue-demi");
const useAutoRunPlugin = (fetchInstance, { manual, ready = true, refreshDeps = [], refreshDepsAction }) => {
  const hasAutoRun = vueDemi.ref(false);
  vueDemi.watchEffect(() => {
    if (!manual)
      hasAutoRun.value = vueDemi.unref(ready);
  });
  if (refreshDeps instanceof Array)
    vueDemi.watch(
      [hasAutoRun, ...refreshDeps],
      ([autoRun]) => {
        if (!autoRun)
          return;
        if (!manual && autoRun) {
          if (refreshDepsAction) {
            refreshDepsAction();
          } else {
            fetchInstance.refresh();
          }
        }
      },
      {
        deep: true,
        immediate: false
      }
    );
  else
    vueDemi.watch(hasAutoRun, (h) => {
      if (!manual && h) {
        if (refreshDepsAction) {
          refreshDepsAction();
        } else {
          fetchInstance.refresh();
        }
      }
    });
  return {
    onBefore: () => {
      if (!vueDemi.unref(ready)) {
        return {
          stopNow: true
        };
      }
    }
  };
};
useAutoRunPlugin.onInit = ({ initialData, ready = true, manual }) => {
  return {
    loading: !manual && vueDemi.unref(ready)
  };
};
module.exports = useAutoRunPlugin;
