"use strict";
const vueDemi = require("vue-demi");
const throttle = require("lodash/throttle");
const _interopDefaultLegacy = (e) => e && typeof e === "object" && "default" in e ? e : { default: e };
const throttle__default = /* @__PURE__ */ _interopDefaultLegacy(throttle);
const useThrottlePlugin = (fetchInstance, { throttleWait, throttleLeading, throttleTrailing }) => {
  const options = vueDemi.computed(() => {
    const ret = {};
    if (vueDemi.unref(throttleLeading) !== void 0) {
      ret.leading = vueDemi.unref(throttleLeading);
    }
    if (vueDemi.unref(throttleTrailing) !== void 0) {
      ret.trailing = vueDemi.unref(throttleTrailing);
    }
    return ret;
  });
  const throttledRef = vueDemi.computed(
    () => throttle__default.default(
      (callback) => {
        callback();
      },
      vueDemi.unref(throttleWait),
      options.value
    )
  );
  vueDemi.watchEffect((onInvalidate) => {
    if (vueDemi.unref(throttleWait)) {
      const _originRunAsync = fetchInstance.runAsync.bind(fetchInstance);
      fetchInstance.runAsync = (...args) => {
        return new Promise((resolve, reject) => {
          var _a;
          (_a = throttledRef.value) == null ? void 0 : _a.call(throttledRef, () => {
            _originRunAsync(...args).then(resolve).catch(reject);
          });
        });
      };
      onInvalidate(() => {
        var _a;
        fetchInstance.runAsync = _originRunAsync;
        (_a = throttledRef.value) == null ? void 0 : _a.cancel();
      });
    }
  });
  if (!vueDemi.unref(throttleWait)) {
    return {};
  }
  return {
    onCancel: () => {
      var _a;
      (_a = throttledRef.value) == null ? void 0 : _a.cancel();
    }
  };
};
module.exports = useThrottlePlugin;
