"use strict";
const vueDemi = require("vue-demi");
function useSet(initialValue) {
  const getInitValue = () => {
    return initialValue === void 0 ? /* @__PURE__ */ new Set() : new Set(initialValue);
  };
  const state = vueDemi.ref(getInitValue());
  const actions = {
    add: (value) => {
      state.value.add(value);
    },
    remove: (value) => {
      state.value.delete(value);
    },
    has: (value) => state.value.has(value),
    clear: () => state.value.clear(),
    reset: () => {
      state.value = getInitValue();
    }
  };
  return [state, vueDemi.markRaw(actions)];
}
module.exports = useSet;
