"use strict";
const vueDemi = require("vue-demi");
const merge = require("lodash/merge");
const _interopDefaultLegacy = (e) => e && typeof e === "object" && "default" in e ? e : { default: e };
const merge__default = /* @__PURE__ */ _interopDefaultLegacy(merge);
function useSetState(initialState) {
  const getInitialState = () => vueDemi.unref(initialState);
  const state = vueDemi.ref(getInitialState());
  const setMergeState = (patch) => {
    const newState = vueDemi.unref(patch);
    state.value = newState ? merge__default.default(state.value, newState) : state.value;
  };
  return [vueDemi.readonly(state), setMergeState];
}
module.exports = useSetState;
