"use strict";
const vueDemi = require("vue-demi");
const useWinResize = require("../useWinResize");
const domTarget = require("../utils/domTarget");
const _interopDefaultLegacy = (e) => e && typeof e === "object" && "default" in e ? e : { default: e };
const useWinResize__default = /* @__PURE__ */ _interopDefaultLegacy(useWinResize);
function useSize(target) {
  const size = vueDemi.reactive({
    width: 0,
    height: 0
  });
  const getSizeInfo = () => {
    var _a, _b;
    const targetDom = domTarget.getTargetElement(target);
    size.width = (_a = targetDom == null ? void 0 : targetDom.clientWidth) != null ? _a : 0;
    size.height = (_b = targetDom == null ? void 0 : targetDom.clientHeight) != null ? _b : 0;
  };
  useWinResize__default.default(getSizeInfo);
  vueDemi.onMounted(() => {
    setTimeout(() => {
      getSizeInfo();
    }, 120);
  });
  return { ...vueDemi.toRefs(size) };
}
module.exports = useSize;
