"use strict";
const vueDemi = require("vue-demi");
const useThrottleFn = require("../useThrottleFn");
const _interopDefaultLegacy = (e) => e && typeof e === "object" && "default" in e ? e : { default: e };
const useThrottleFn__default = /* @__PURE__ */ _interopDefaultLegacy(useThrottleFn);
function useThrottle(value, options) {
  const throttled = vueDemi.ref();
  throttled.value = value.value;
  const { run } = useThrottleFn__default.default(() => {
    throttled.value = value.value;
  }, options);
  vueDemi.watch(
    value,
    () => {
      run.value();
    },
    {
      immediate: true
    }
  );
  return throttled;
}
module.exports = useThrottle;
