"use strict";
const vueDemi = require("vue-demi");
function useTimeout(fn, delay, options) {
  const immediate = options == null ? void 0 : options.immediate;
  if (immediate) {
    fn();
  }
  vueDemi.watchEffect((onInvalidate) => {
    if (vueDemi.unref(delay) === void 0 || typeof vueDemi.unref(delay) !== "number" || vueDemi.unref(delay) < 0)
      return;
    const _deply = vueDemi.unref(delay);
    const timer = setTimeout(() => {
      fn();
    }, _deply);
    onInvalidate(() => {
      clearInterval(timer);
    });
  });
}
module.exports = useTimeout;
