"use strict";
const vueDemi = require("vue-demi");
const isBrowser = require("../utils/isBrowser");
const _interopDefaultLegacy = (e) => e && typeof e === "object" && "default" in e ? e : { default: e };
const isBrowser__default = /* @__PURE__ */ _interopDefaultLegacy(isBrowser);
const DEFAULT_OPTIONS = {
  restoreOnUnmount: false
};
function useTitle(title, options = DEFAULT_OPTIONS) {
  const titleRef = vueDemi.ref(isBrowser__default.default ? document.title : "");
  if (vueDemi.isRef(title)) {
    vueDemi.watch(title, () => {
      document.title = title.value;
    });
  } else
    document.title = title;
  vueDemi.onMounted(() => {
    document.title = vueDemi.unref(title);
  });
  vueDemi.onUnmounted(() => {
    if (options.restoreOnUnmount) {
      document.title = vueDemi.unref(titleRef);
    }
  });
}
module.exports = useTitle;
