"use strict";
const vueDemi = require("vue-demi");
function useToggle(defaultValue = false, reverseValue) {
  const state = vueDemi.ref(defaultValue);
  const actions = vueDemi.computed(() => {
    const reverseValueOrigin = reverseValue === void 0 ? !defaultValue : reverseValue;
    const toggle = () => {
      state.value = state.value === defaultValue ? reverseValueOrigin : defaultValue;
    };
    const set = (value) => state.value = value;
    const setLeft = () => state.value = defaultValue;
    const setRight = () => state.value = reverseValueOrigin;
    return {
      toggle,
      set,
      setLeft,
      setRight
    };
  });
  return [state, { ...actions.value }];
}
module.exports = useToggle;
