"use strict";
const vueDemi = require("vue-demi");
function useWhyDidYouUpdate(componentName, props) {
  const keys = vueDemi.computed(() => Object.keys(props).map((key) => key));
  vueDemi.watch(
    Object.keys(props).map((key) => props[key]),
    (curr, prev) => {
      const changedProps = {};
      keys.value.forEach((key, index) => {
        if (prev[index] !== curr[index]) {
          changedProps[key] = {
            from: prev[index],
            to: curr[index]
          };
        }
      });
      if (Object.keys(changedProps).length) {
        console.log("[why-did-you-update]", componentName, changedProps);
      }
    },
    {
      deep: true
    }
  );
}
module.exports = useWhyDidYouUpdate;
